import AppsStore from './../stores/apps.js'

/**
 *  handler for apps
 *
 *  @author Björn Hase
 *  @license hhttps://www.gnu.org/licenses/gpl-3.0.en.html GPL-3
 *  @link https://gitea.node001.net/HerrHase/tellme-bot.git
 *
 */
class AppsHandler {

    /**
     *  use create in appStore and send event with result to app
     *
     *  @param  {object} data
     *  @return {object}
     *
     */
    create(connector, data) {
        const appsStore = new AppsStore()

        appsStore.create(data)
            .then((data) => {
                connector.send('pouchdb.apps.success', data)
            })
    }

    /**
     *  use update in appStore and send event with result to app
     *
     *  @param  {object} data
     *  @return {object}
     *
     */
    update(connector, data) {
        const appsStore = new AppsStore()

        appsStore.update(data)
            .then((data) => {
                connector.send('pouchdb.apps.success', data)
            })
    }

    /**
     *  use find in appStore and send event with result to app
     *
     *  @param  {object} connector
     *  @param  {object} data
     *
     */
    find(connector, data) {
        const appsStore = new AppsStore()

        appsStore.find()
            .then((data) => {
                connector.send('pouchdb.apps.ready', data)
            })
    }
}

export default AppsHandler